function varargout = clustree(varargin)
% CLUSTREE M-file for clustree.fig
%      CLUSTREE, by itself, creates a newTag CLUSTREE or raises the existing
%      singleton*.
%
%      H = CLUSTREE returns the handle to a newTag CLUSTREE or the handle to
%      the existing singleton*.
%
%      CLUSTREE('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in CLUSTREE.M with the given input arguments.
%
%      CLUSTREE('Property','Value',...) creates a newTag CLUSTREE or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before clustree_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to clustree_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help clustree

% Last Modified by GUIDE v2.5 07-Jan-2007 12:07:56

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @clustree_OpeningFcn, ...
    'gui_OutputFcn',  @clustree_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before clustree is made visible.
function clustree_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to clustree (see VARARGIN)

% Choose default command line output for clustree
handles.output = hObject;
handles.dataInput=[];
handles.realClass=[];
handles.emptyRealMapping=1;
handles.loaded=0;

handles.paintLevel=2;
handles.useFDR=1;
handles.paintFactor=3;
handles.threshold=0.05;
handles.majority=0.5;
% Update handles structure
guidata(hObject, handles);

% UIWAIT makes clustree wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = clustree_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in exitTag.
function exitTag_Callback(hObject, eventdata, handles)
% hObject    handle to exitTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selection = questdlg(['Close ' get(handles.figure1,'Name') '?'],...
    ['Close ' get(handles.figure1,'Name') '...'],...
    'Yes','No','Yes');
if strcmp(selection,'No')
    return;
end

delete(handles.figure1)
% --- Executes on button press in exportTag.
function exportTag_Callback(hObject, eventdata, handles)
% hObject    handle to exportTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global selectedBranch;
if selectedBranch
    button = questdlg('Export data as A..','Secify Target','Variable','File','Cancel','Variable');
    if strcmp(button,'Variable')
        [elements, pVal] = retrieveExportedDate(selectedBranch);
        prompt = {'Branch Id:' ,'Elements:','P-Value:'};
        dlg_title = 'Specify Variables';
        num_lines = 1;
        def = {'branch','elements','pval'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        if isempty(answer) == 0
            assignin('base',answer{1},selectedBranch);
            assignin('base',answer{2},elements);
            assignin('base',answer{3},pVal);
        end
    elseif strcmp(button,'File')
        [elements, pVal] = retrieveExportedDate(selectedBranch);
        [filename, pathname, filterindex] = uiputfile( ...
            {'*.txt','Text file (*.txt)';...
            '*.*',  'All Files (*.*)'}, ...
            'Save as');
        if isempty(filename) ==0
            branchStr = ['Branch ' num2str(selectedBranch)];
            elementsStr = ['Elements ' num2str(elements)];
            pValStr =['P-Value ' num2str(pVal)];
            fid = fopen(filename, 'wt');
            fprintf(fid, '%s\n%s\n\%s', branchStr,elementsStr,pValStr);
            fclose(fid)
        end
    end
else
    message = sprintf('No Branch was selected!\n, Please select a branch and then export');
    title = ['Bad Selection'];
    msgbox(message,title,'warn');
end


% --------------------------------------------------------------------
function [elements, pVal] = retrieveExportedDate(selectedBranch)
global hash;
elements= elementsBelow(hash(:,2) ,hash (:,1),selectedBranch);
ind = find(hash(:,1) == selectedBranch);
pVal = hash(ind,6);
% --------------------------------------------------------------------
function openTag_Callback(hObject, eventdata, handles)
% hObject    handle to openTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[file, dir, filterindex] = uigetfile({'*.mat', 'MATLAB data Files (*.mat)';'*.dat', 'ASCII Files (*.dat)'}, 'Load Tree');

if (filterindex~=0)
    full_file = fullfile(dir,file);
    load (full_file);
    %if check...
    handles.loaded=1;
    handles.parents = parents(:,1:2);
    handles.realClass=realClass;
    set(handles.loadedTag,'String',file );
    set(handles.loadedTag,'ForegroundColor',[0 0 0]);%black
    set(handles.scoreTag,'String','C Score = XXX');
set(handles.JFScoresTag,'String','J Score = XXX, F Score= XXX');
end
guidata(hObject, handles);


% --- Executes during object creation, after setting all properties.
function edit2_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

function flash(hObject, eventdata, handles)
set(handles.loadedTag,'String','Wait for Building' );
set(handles.loadedTag,'ForegroundColor',[1 0 0]);%red
set(handles.scoreTag,'String','C Score = XXX');
set(handles.JFScoresTag,'String','J Score = XXX, F Score= XXX');
guidata(hObject, handles);
plot(handles.axesTag,0,0)  ;
guidata(handles.axesTag, handles);
% --- Executes on button press in buildTag.
function buildTag_Callback(hObject, eventdata, handles)
% hObject    handle to buildTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if    handles.loaded
   flash(hObject, eventdata, handles);
    [cscore,fscore,jscore] = buildTree(handles.parents,handles.realClass,handles.paintLevel,handles.paintFactor,handles.useFDR,handles.threshold,handles.majority,handles.axesTag);
  set(handles.loadedTag,'String',' Building Done' );
set(handles.loadedTag,'ForegroundColor',[0 0 0]);%black
    if  handles.paintLevel ==2
        set(handles.scoreTag,'String',['C Score = ', num2str(cscore)]);
        set(handles.JFScoresTag,'String',['J Score = ', num2str(jscore), ',   F Score= ',num2str(fscore) ]);
    end
end
guidata(hObject, handles);



% --- Executes during object creation, after setting all properties.
function axesTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to axesTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: place code in OpeningFcn to populate axesTag
axis off


% --- Executes on button press in fdrTag.
function fdrTag_Callback(hObject, eventdata, handles)
% hObject    handle to fdrTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of fdrTag




% --------------------------------------------------------------------
function fileMenuTag_Callback(hObject, eventdata, handles)
% hObject    handle to fileMenuTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function printTag_Callback(hObject, eventdata, handles)
% hObject    handle to printTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

printdlg(handles);
% --------------------------------------------------------------------
function saveAsTag_Callback(hObject, eventdata, handles)
% hObject    handle to saveAsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[file, dir, filterindex] = uiputfile( ...
    {'*.fig', 'MATLAB figure Files (*.fig)';'*.bmp','Bitmap files (*.bmp)'; '*.eps','EPS Level 1 (*.eps)'; '*.*',  'All Files (*.*)'}, ...
    'Save as');
if (filterindex~=0)
    full_file = fullfile(dir,file);
    saveas(handles.axesTag,full_file);
end




function paintFactorTag_Callback(hObject, eventdata, handles)
% hObject    handle to paintFactorTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of paintFactorTag as text
%        str2double(get(hObject,'String')) returns contents of paintFactorTag as a double




% --------------------------------------------------------------------
function aboutTag_Callback(hObject, eventdata, handles)
% hObject    handle to aboutTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
about;

% --------------------------------------------------------------------
function HelpTag_Callback(hObject, eventdata, handles)
% hObject    handle to HelpTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --------------------------------------------------------------------
function newTag_Callback(hObject, eventdata, handles)
% hObject    handle to newTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[varsout{1:5}] =clusteringOptions('dataInput',[],'realOutput',[],'samplesAreRaws',[]);
dataInputStr=varsout{2};
realOutputStr=varsout{3};
selectedAlg =varsout{4};
isCancel =varsout{5};
if isCancel
    return
else
    set(handles.loadedTag,'String','Wait for Clustering' );
    set(handles.loadedTag,'ForegroundColor',[1 0 0]);%red
    guidata(hObject, handles);
    if selectedAlg ~= 2
        handles.dataInput =evalin('base',dataInputStr);
        if isempty(realOutputStr)% if there is no output mapping --> we'll construct a dummy one
            handles.emptyRealMapping = 1;% a flag
            handles.realClass = ones(size(handles.dataInput,1),1);
        else
            handles.realClass =evalin('base',realOutputStr);
            handles.emptyRealMapping = 0;% a flag
        end
    end
    switch selectedAlg
        case 1%agglomerative
            [varsout{1:4}] = aggClustOpt;
            dist =varsout{2} ;
            link = varsout{3};
            dataRepresentation = varsout{4};% distance= 0,  similarity= 1, raw = 2;
            if ( varsout{1} == 0 )
                return;
            else
                switch dataRepresentation
                    case 0% distance= 0
                        Y = blastDistance(handles.dataInput);
                    case 1%similarity= 1
                        [dists] = similarity2Distance(handles.dataInput);
                        Y = blastDistance(dists);
                    case 2
                        Y = pdist(handles.dataInput,dist);
                end
                Z = linkage(Y,link);
                handles.parents = Z(:,1:2);
                handles.note = sprintf('Agglomerative (d=%s, type=%s)', varsout{2}, varsout{3});
            end %cancel
        case 2%TDQC
            [varsout{1:4}] = tdqcOpt;
            if ( varsout{1} == 0 )
                return;
            else
                if (varsout{1} == 1)%from file 
                    file =varsout{2} ;
                    [familyTree,partitionMatrix,parents]=recCompact(file,0,2,2,1, 0);          
                    handles.note = sprintf('TDQC (Params File: %s)', varsout{2});
                else
                    [familyTree,partitionMatrix,parents]=tdqc(dataInputStr,varsout{3}, varsout{4});
                    handles.note = sprintf('TDQC (Params: dimensions = %s, sigma = %s)', varsout{3},varsout{4});
                end
                handles.parents = parents;    
                if length(realOutputStr)
                    handles.emptyRealMapping = 0;% a flag
                    handles.realClass =evalin('base',realOutputStr);
                end
            end
        case 3
            if isempty(which ('getclusters1'))
                errordlg(sprintf('You do not have PDDP installed\nPlease Check http://www-users.cs.umn.edu/~boley/PDDP.html'),'Missing PDDP');
            else
                [out,pvis,titel,Ms]=getclusters1(handles.dataInput',size(handles.dataInput,2),[],4);
                [tree,handles.parents]=postProcesPDDP(out);
                handles.note = sprintf('PDDP');
            end
    end
    handles.loaded =1;
    set(handles.loadedTag,'String','Loaded' );
    set(handles.loadedTag,'ForegroundColor',[0 0 0]);%black
    guidata(hObject, handles);
end

% --------------------------------------------------------------------
function treeOptTag_Callback(hObject, eventdata, handles)
% hObject    handle to treeOptTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

[varsout{1:6}] = treeOpt(0,0,...
    'level',handles.paintLevel,'fdr', handles.useFDR,'factor',handles.paintFactor,'threshold', handles.threshold,'majority',handles.majority);
if ( varsout{1} == 0 )
    return;
else
    handles.paintLevel=varsout{2};
    handles.useFDR=varsout{3};
    handles.paintFactor=varsout{4};
    handles.threshold = varsout{5};
    handles.majority=varsout{6};
    guidata(hObject, handles);
end
flash (hObject, eventdata, handles);
% --------------------------------------------------------------------
function Untitled_1_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% --------------------------------------------------------------------
function saveResultsTag_Callback(hObject, eventdata, handles)
% hObject    handle to saveResultsTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
[file, dir, filterindex] = uiputfile( ...
    {'*.mat', 'MATLAB Data Files (*.mat)';'*.dat', 'ASCII Files (*.dat)'; '*.*',  'All Files (*.*)'},'Save as');
if filterindex== 0
    return;
end
full_file = fullfile(dir,file);
parents=handles.parents;
realClass=handles.realClass;
switch filterindex
    case 1 % mat format
        save(full_file, 'parents', 'realClass');
    case 2 % ASCII format
        save(full_file, 'parents', 'realClass','-ASCII');
end

% --------------------------------------------------------------------
function Untitled_5_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_5 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


% --------------------------------------------------------------------
function distributeTag_Callback(hObject, eventdata, handles)
% hObject    handle to distributeTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if (handles.paintLevel >0) & length(handles.realClass)
    [varsout{1:5}] = scoresDistribution(0,0, 'threshold',handles.threshold);
else
    errordlg (sprintf('%s\n%s\n%s\n%s', ...
        'Score distribution is optional only when:','Real classification is available'...
        ,'Leaves or Branches paiting options','Please set the Tree Options (Ctrl +T)'));
end

% --------------------------------------------------------------------
function Untitled_6_Callback(hObject, eventdata, handles)
% hObject    handle to Untitled_6 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)




% --------------------------------------------------------------------
function ultrametricMenuTag_Callback(hObject, eventdata, handles)
% hObject    handle to ultrametricMenuTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
if handles.loaded 
    ultrametricDisp;  
else
    errordlg (sprintf('%s\n%s', ...
        'Ultrametric Analysis is optional only when a tree is loaded','Please build or load a tree'));
end




% --------------------------------------------------------------------
function exportMenuTag_Callback(hObject, eventdata, handles)
% hObject    handle to exportMenuTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global selectedBranch;
if selectedBranch
    button = questdlg('Export data as A..','Secify Target','Variable','File','Cancel','Variable');
    if strcmp(button,'Variable')
        [elements, pVal] = retrieveExportedDate(selectedBranch);
        prompt = {'Branch Id:' ,'Elements:','P-Value:'};
        dlg_title = 'Specify Variables';
        num_lines = 1;
        def = {'branch','elements','pval'};
        answer = inputdlg(prompt,dlg_title,num_lines,def);
        if isempty(answer) == 0
            assignin('base',answer{1},selectedBranch);
            assignin('base',answer{2},elements);
            assignin('base',answer{3},pVal);
        end
    elseif strcmp(button,'File')
        [elements, pVal] = retrieveExportedDate(selectedBranch);
        [filename, pathname, filterindex] = uiputfile( ...
            {'*.txt','Text file (*.txt)';...
            '*.*',  'All Files (*.*)'}, ...
            'Save as');
        if isempty(filename) ==0
            branchStr = ['Branch ' num2str(selectedBranch)];
            elementsStr = ['Elements ' num2str(elements)];
            pValStr =['P-Value ' num2str(pVal)];
            fid = fopen(filename, 'wt');
            fprintf(fid, '%s\n%s\n\%s', branchStr,elementsStr,pValStr);
            fclose(fid)
        end
    end
else
    message = sprintf('No Branch was selected!\nPlease select a branch and then export');
    title = ['Bad Selection'];
    msgbox(message,title,'warn');
end
% --- Executes on button press in exitBTag.
function exitBTag_Callback(hObject, eventdata, handles)
% hObject    handle to exitBTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

exitTag_Callback(handles.exitTag, eventdata, handles);
