function varargout = treeOpt(varargin)
% TREEOPT M-file for treeOpt.fig
%      TREEOPT, by itself, creates a new TREEOPT or raises the existing
%      singleton*.
%
%      H = TREEOPT returns the handle to a new TREEOPT or the handle to
%      the existing singleton*.
%
%      TREEOPT('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in TREEOPT.M with the given input arguments.
%
%      TREEOPT('Property','Value',...) creates a new TREEOPT or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before treeOpt_OpeningFunction gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to treeOpt_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Copyright 2002-2003 The MathWorks, Inc.

% Edit the above text to modify the response to help treeOpt

% Last Modified by GUIDE v2.5 06-Dec-2006 18:05:52

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @treeOpt_OpeningFcn, ...
    'gui_OutputFcn',  @treeOpt_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before treeOpt is made visible.
function treeOpt_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to treeOpt (see VARARGIN)

% Choose default command line output for treeOpt
handles.output = hObject;
handles.mode = 0;
handles.paintLevel=2;
handles.useFDR=0;
handles.paintFactor=3;
handles.threshold=0.05;
handles.majority=0.5;

if(nargin > 3)
    for index = 1:2:(nargin-3),
        if nargin-3==index break, end
        switch lower(varargin{index})
            case 'level'
                handles.paintLevel= varargin{index+1};
                switch  handles.paintLevel
                    case 0
                        set(handles.blackTag,'Value',1);
                    case 1
                        set(handles.leavesTag,'Value',1);
                    case 2
                        set(handles.allTag,'Value',1);
                end
            case 'fdr'
                handles.useFDR= varargin{index+1};
                set(handles.fdrTag,'Value',handles.useFDR)  ;
            case 'factor'
                handles.paintFactor= varargin{index+1};
                set(handles.paintTag,'String',num2str(handles.paintFactor));
            case 'threshold'
                handles.threshold= varargin{index+1};
                set(handles.thresholdTag,'String',num2str(handles.threshold));
                   case 'majority'
                handles.majority= varargin{index+1};
                set(handles.majoritySizeTag,'String',num2str(handles.majority));
        end
    end
end
% Make the GUI modal
set(handles.figure1,'WindowStyle','modal');
% Update handles structure
guidata(hObject, handles);
% UIWAIT makes numOfClassesDlg wait for user response (see UIRESUME)
uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = treeOpt_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure

varargout{1} = handles.mode;
varargout{2}=handles.paintLevel;
varargout{3}=handles.useFDR;
varargout{4} =handles.paintFactor;
varargout{5} =handles.threshold;

varargout{6} =handles.majority;
delete(handles.figure1);

% --- Executes on button press in cancelButton.
function cancelButton_Callback(hObject, eventdata, handles)
% hObject    handle to cancelButton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Just close the figure, the default mode is anyway zero (to support other
% ways of closing the dialog
uiresume(handles.figure1);

% --- Executes on button press in fdrTag.
function fdrTag_Callback(hObject, eventdata, handles)
% hObject    handle to fdrTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of fdrTag

function paintTag_Callback(hObject, eventdata, handles)
% hObject    handle to paintTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of paintTag as text
%        str2double(get(hObject,'String')) returns contents of paintTag as a double


% --- Executes during object creation, after setting all properties.
function paintTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to paintTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in applyBotton.
function applyBotton_Callback(hObject, eventdata, handles)
% hObject    handle to applyBotton (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

if    get(handles.blackTag,'Value')
    handles.paintLevel =0;
elseif get(handles.leavesTag,'Value')
    handles.paintLevel =1;
else
    handles.paintLevel =2;
end
handles.useFDR = get(handles.fdrTag,'Value');
handles.paintFactor = str2num(get(handles.paintTag,'String'));
handles.threshold=str2num(get(handles.thresholdTag,'String'));
if get(handles.majorityTag,'Value')
     handles.majority = str2num(get(handles.majoritySizeTag,'String'));
     if  handles.majority <0 | handles.majority >1
         error('Majority values must be between 0 and 1');
     else
         handles.mode = 1;
     end
else
        handles.mode = 1;
end
guidata(hObject, handles);
uiresume(handles.figure1);

function thresholdTag_Callback(hObject, eventdata, handles)
% hObject    handle to thresholdTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of thresholdTag as text
%        str2double(get(hObject,'String')) returns contents of thresholdTag as a double


% --- Executes during object creation, after setting all properties.
function thresholdTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to thresholdTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in majorityTag.
function majorityTag_Callback(hObject, eventdata, handles)
% hObject    handle to majorityTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of majorityTag
valStr = 'off';
if get(hObject,'Value')
    valStr = 'on';
end
set(handles. majoritySizeTag,'Enable',valStr);
guidata(hObject, handles);

function majoritySizeTag_Callback(hObject, eventdata, handles)
% hObject    handle to majoritySizeTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of majoritySizeTag as text
%        str2double(get(hObject,'String')) returns contents of majoritySizeTag as a double


% --- Executes during object creation, after setting all properties.
function majoritySizeTag_CreateFcn(hObject, eventdata, handles)
% hObject    handle to majoritySizeTag (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


